#! /bin/sh

# Test recognition of Qt format strings.

tmpfiles=""
trap 'rm -fr $tmpfiles' 1 2 3 15

tmpfiles="$tmpfiles f-qt-1.data"
cat <<\EOF > f-qt-1.data
# Unrecognized: no argument
"abc%%def"
# Valid: one argument
"abc%1def"
# Valid: one argument
"abc%9def"
# Valid: unterminated
"abc%1def%"
# Valid: non-digit
"abc%1def%x"
# Valid: zero
"abc%1def%0"
# Valid: permutation
"abc%2def%1"
# Invalid: multiple uses of same argument
"abc%2def%1ghi%2"
EOF

: ${XGETTEXT=xgettext}
n=0
while read comment; do
  read string
  n=`expr $n + 1`
  tmpfiles="$tmpfiles f-qt-1-$n.in f-qt-1-$n.po"
  cat <<EOF > f-qt-1-$n.in
_(${string});
EOF
  ${XGETTEXT} -L C++ --qt -k_ -o f-qt-1-$n.po f-qt-1-$n.in || exit 1
  test -f f-qt-1-$n.po || exit 1
  fail=
  if echo "$comment" | grep 'Valid:' > /dev/null; then
    if grep qt-format f-qt-1-$n.po > /dev/null; then
      :
    else
      fail=yes
    fi
  else
    if grep qt-format f-qt-1-$n.po > /dev/null; then
      fail=yes
    else
      :
    fi
  fi
  if test -n "$fail"; then
    echo "Format string recognition error:" 1>&2
    cat f-qt-1-$n.in 1>&2
    echo "Got:" 1>&2
    cat f-qt-1-$n.po 1>&2
    exit 1
  fi
  rm -f f-qt-1-$n.in f-qt-1-$n.po
done < f-qt-1.data

rm -fr $tmpfiles

exit 0
